import java.util.ArrayList;


public class Helicopter {
	private Point point;
	private double height;
	
	public Helicopter(Point point, double height) {
		this.point = point;
		this.height = height;
	}
	
	public Point getPoint() {
		return this.point;
	}
	
	public void changeHeight(double d) {
		this.height += d;
	}
	
	public boolean isVisible(Point p) {

		ArrayList<Point> pointsBetween = this.point.getTerrain().useVisionLine(this.point, p);
		for (Point t : pointsBetween) {
			if (t.getZ() >
					(this.height - p.getZ()) *
					 DistanceCalculator.distanceFromPointToPoint(
							p.getX(), p.getY(), t.getX(), t.getY()) / 
					 DistanceCalculator.distanceFromPointToPoint(
							p.getX(), p.getY(), this.getPoint().getX(), this.getPoint().getY()) +
					 p.getZ()) {
				
				return false;
			}
		}
		
		return true;
	}
	
	public void move(char dir) {
		Point point = this.point.getAdjacentPoint(dir);
		if (point != null && point.getZ() <= this.height) {
			this.point = point;
		}
	}
	
	public void move(Point point) {
		if (point != null && point.getZ() <= this.height) {
			this.point = point;
		}
	}
	
	public double getHeight() {
		return this.height;
	}
	
	public String toString() {
		return this.point.getX() + "," + this.point.getY() + "," + this.height;
	}

}
