
public class Point {
	private Terrain terrain;
	private int x;
	private int y;
	private double z;
	
	public Point(Terrain terrain, int x, int y, double z) {
		this.terrain = terrain;
		this.x = x;
		this.y = y;
		this.z = z;
	}
	
	public Terrain getTerrain() {
		return this.terrain;
	}
	
	public void setTerrain(Terrain terrain) {
		this.terrain = terrain;
	}
	
	public int getX() {
		return this.x;
	}
	
	public int getY() {
		return this.y;
	}
	
	public double getZ() {
		return this.z;
	}

	public Point getAdjacentPoint(char dir) {
		if (dir == 'U') {
			return this.terrain.getPoint(this.x, this.y - 1);
		} else if (dir == 'D') {
			return this.terrain.getPoint(this.x, this.y + 1);
		} else if (dir == 'L') {
			return this.terrain.getPoint(this.x - 1, this.y);
		} else if (dir == 'R') {
			return this.terrain.getPoint(this.x + 1, this.y);
		} else {
			return null;
		}
	}
	
	public String toString() {
		return "(" + this.x + "," + this.y + "," + this.z + ")";
	}
}
