import java.util.ArrayList;


public class Track {
	private ArrayList<Point> points;
	private Helicopter helicopter;
	private int i;
	
	public Track(ArrayList<Point> points) {
		this.points = points;
		this.i = 0;
		this.helicopter = new Helicopter(this.points.get(0), RescueOperation.HELICOPTER_HEIGHT);
	}
	
	public ArrayList<Point> getPoints() {
		return this.points;
	}
	
	public Point getStart() {
		return this.points.get(0);
	}
	
	public Point getEnd() {
		return this.points.get(this.points.size() - 1);
	}
	
	public int getI() {
		return this.i;
	}
	
	public Helicopter getHelicopter() {
		return this.helicopter;
	}
	
	public Point getHelicopterPoint() {
		return this.helicopter.getPoint();
	}
	
	public void moveHelicopterForwards() {
		if (this.i != this.points.size() - 1) {
			this.i++;
			this.helicopter.move(this.points.get(this.i));
		}
	}
	
	public void moveHelicopterBackwards() {
		if (this.i != 0) {
			this.i--;
			this.helicopter.move(this.points.get(this.i));
		}
	}

}
