function d = distanceFromPointToSegment( x0, y0, x1, y1, x2, y2 )
% Distance from point (x0, y0) to line segment between points (x1, y1) and (x2, y2).

k = -1 / ((y1 - y2) / (x1 - x2));
ym = k * x0 - k * x1 + y1;
yn = k * x0 - k * x2 + y2;

if y0 > min(ym, yn) && y0 < max(ym, yn)
    d = distanceFromPointToLine(x0, y0, x1, y1, x2, y2);
else
    d = min(distanceFromPointToPoint(x0, y0, x1, y1), distanceFromPointToPoint(x0, y0, x2, y2));
end

end

