function Z = loadTerrain( file_name )
% Loads the terrain from file.

width = 60;
height = 60;

ridges = [];
      
file = fopen(file_name, 'r');
tline = fgets(file);
ridge_height = str2double(tline);
tline = fgets(file);
ridge_std = str2double(tline);
tline = fgets(file);
while ischar(tline)
%    lineData = regexp(tline, ' ', 'split');
%    http://www.mathworks.com/matlabcentral/newsreader/view_thread/172341
    lineData = regexp(tline, '[^ ]*', 'match');
    x1 = str2double(cell2mat(lineData(1)));
    y1 = str2double(cell2mat(lineData(2)));
    x2 = str2double(cell2mat(lineData(3)));
    y2 = str2double(cell2mat(lineData(4)));
    ridges = [ridges; x1 y1 x2 y2];
    tline = fgets(file);
end
fclose(file);

%ridge_height
%ridge_std
%ridges

Z = zeros(width, height);

for y = 1:height
    for x = 1:width
        for r = 1:size(ridges, 1)
            d = distanceFromPointToSegment(x, y, ...
                                           ridges(r, 1), ridges(r, 2), ...
                                           ridges(r, 3), ridges(r, 4));
            f = ridge_height * exp(-d^2 / (2 * ridge_std^2));
            Z(x, y) = max(Z(x, y), f);
        end
    end
end

end

